/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/drcsim-3.2.0/atlas_msgs/msg/AtlasBehaviorManipulateParams.msg
 *
 */


#ifndef ATLAS_MSGS_MESSAGE_ATLASBEHAVIORMANIPULATEPARAMS_H
#define ATLAS_MSGS_MESSAGE_ATLASBEHAVIORMANIPULATEPARAMS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <atlas_msgs/AtlasBehaviorPelvisServoParams.h>

namespace atlas_msgs
{
template <class ContainerAllocator>
struct AtlasBehaviorManipulateParams_
{
  typedef AtlasBehaviorManipulateParams_<ContainerAllocator> Type;

  AtlasBehaviorManipulateParams_()
    : use_desired(false)
    , desired()
    , use_demo_mode(false)  {
    }
  AtlasBehaviorManipulateParams_(const ContainerAllocator& _alloc)
    : use_desired(false)
    , desired(_alloc)
    , use_demo_mode(false)  {
    }



   typedef uint8_t _use_desired_type;
  _use_desired_type use_desired;

   typedef  ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator>  _desired_type;
  _desired_type desired;

   typedef uint8_t _use_demo_mode_type;
  _use_demo_mode_type use_demo_mode;




  typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct AtlasBehaviorManipulateParams_

typedef ::atlas_msgs::AtlasBehaviorManipulateParams_<std::allocator<void> > AtlasBehaviorManipulateParams;

typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorManipulateParams > AtlasBehaviorManipulateParamsPtr;
typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorManipulateParams const> AtlasBehaviorManipulateParamsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace atlas_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'atlas_msgs': ['/tmp/buildd/drcsim-3.2.0/atlas_msgs/msg', '/tmp/buildd/drcsim-3.2.0/obj-x86_64-linux-gnu/devel/share/atlas_msgs/msg'], 'sandia_hand_msgs': ['/opt/ros/groovy/share/sandia_hand_msgs/cmake/../msg'], 'osrf_msgs': ['/opt/ros/groovy/share/osrf_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'control_msgs': ['/opt/ros/groovy/share/control_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >
{
  static const char* value()
  {
    return "c4e967ec87266f9e108243e7ac4b9614";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xc4e967ec87266f9eULL;
  static const uint64_t static_value2 = 0x108243e7ac4b9614ULL;
};

template<class ContainerAllocator>
struct DataType< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >
{
  static const char* value()
  {
    return "atlas_msgs/AtlasBehaviorManipulateParams";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# mirrored from AtlasControlTypes.h\n\
bool use_desired\n\
atlas_msgs/AtlasBehaviorPelvisServoParams desired\n\
bool use_demo_mode\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorPelvisServoParams\n\
# mirrored from AtlasControlTypes.h\n\
\n\
float64 pelvis_height\n\
float64 pelvis_yaw\n\
float64 pelvis_lat\n\
\n\
";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.use_desired);
      stream.next(m.desired);
      stream.next(m.use_demo_mode);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct AtlasBehaviorManipulateParams_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::atlas_msgs::AtlasBehaviorManipulateParams_<ContainerAllocator>& v)
  {
    s << indent << "use_desired: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.use_desired);
    s << indent << "desired: ";
    s << std::endl;
    Printer< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >::stream(s, indent + "  ", v.desired);
    s << indent << "use_demo_mode: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.use_demo_mode);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ATLAS_MSGS_MESSAGE_ATLASBEHAVIORMANIPULATEPARAMS_H
