/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/drcsim-3.2.0/atlas_msgs/msg/AtlasBehaviorPelvisServoParams.msg
 *
 */


#ifndef ATLAS_MSGS_MESSAGE_ATLASBEHAVIORPELVISSERVOPARAMS_H
#define ATLAS_MSGS_MESSAGE_ATLASBEHAVIORPELVISSERVOPARAMS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace atlas_msgs
{
template <class ContainerAllocator>
struct AtlasBehaviorPelvisServoParams_
{
  typedef AtlasBehaviorPelvisServoParams_<ContainerAllocator> Type;

  AtlasBehaviorPelvisServoParams_()
    : pelvis_height(0.0)
    , pelvis_yaw(0.0)
    , pelvis_lat(0.0)  {
    }
  AtlasBehaviorPelvisServoParams_(const ContainerAllocator& _alloc)
    : pelvis_height(0.0)
    , pelvis_yaw(0.0)
    , pelvis_lat(0.0)  {
    }



   typedef double _pelvis_height_type;
  _pelvis_height_type pelvis_height;

   typedef double _pelvis_yaw_type;
  _pelvis_yaw_type pelvis_yaw;

   typedef double _pelvis_lat_type;
  _pelvis_lat_type pelvis_lat;




  typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct AtlasBehaviorPelvisServoParams_

typedef ::atlas_msgs::AtlasBehaviorPelvisServoParams_<std::allocator<void> > AtlasBehaviorPelvisServoParams;

typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorPelvisServoParams > AtlasBehaviorPelvisServoParamsPtr;
typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorPelvisServoParams const> AtlasBehaviorPelvisServoParamsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace atlas_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'atlas_msgs': ['/tmp/buildd/drcsim-3.2.0/atlas_msgs/msg', '/tmp/buildd/drcsim-3.2.0/obj-x86_64-linux-gnu/devel/share/atlas_msgs/msg'], 'sandia_hand_msgs': ['/opt/ros/groovy/share/sandia_hand_msgs/cmake/../msg'], 'osrf_msgs': ['/opt/ros/groovy/share/osrf_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'control_msgs': ['/opt/ros/groovy/share/control_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >
{
  static const char* value()
  {
    return "82f59d8aa26e61afaf2c8dbb7b4e7856";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x82f59d8aa26e61afULL;
  static const uint64_t static_value2 = 0xaf2c8dbb7b4e7856ULL;
};

template<class ContainerAllocator>
struct DataType< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >
{
  static const char* value()
  {
    return "atlas_msgs/AtlasBehaviorPelvisServoParams";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# mirrored from AtlasControlTypes.h\n\
\n\
float64 pelvis_height\n\
float64 pelvis_yaw\n\
float64 pelvis_lat\n\
\n\
";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.pelvis_height);
      stream.next(m.pelvis_yaw);
      stream.next(m.pelvis_lat);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct AtlasBehaviorPelvisServoParams_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::atlas_msgs::AtlasBehaviorPelvisServoParams_<ContainerAllocator>& v)
  {
    s << indent << "pelvis_height: ";
    Printer<double>::stream(s, indent + "  ", v.pelvis_height);
    s << indent << "pelvis_yaw: ";
    Printer<double>::stream(s, indent + "  ", v.pelvis_yaw);
    s << indent << "pelvis_lat: ";
    Printer<double>::stream(s, indent + "  ", v.pelvis_lat);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ATLAS_MSGS_MESSAGE_ATLASBEHAVIORPELVISSERVOPARAMS_H
