/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/drcsim-3.2.0/atlas_msgs/msg/AtlasBehaviorStepFeedback.msg
 *
 */


#ifndef ATLAS_MSGS_MESSAGE_ATLASBEHAVIORSTEPFEEDBACK_H
#define ATLAS_MSGS_MESSAGE_ATLASBEHAVIORSTEPFEEDBACK_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <atlas_msgs/AtlasBehaviorStepData.h>

namespace atlas_msgs
{
template <class ContainerAllocator>
struct AtlasBehaviorStepFeedback_
{
  typedef AtlasBehaviorStepFeedback_<ContainerAllocator> Type;

  AtlasBehaviorStepFeedback_()
    : status_flags(0)
    , t_step_rem(0.0)
    , current_step_index(0)
    , next_step_index_needed(0)
    , desired_step_saturated()  {
    }
  AtlasBehaviorStepFeedback_(const ContainerAllocator& _alloc)
    : status_flags(0)
    , t_step_rem(0.0)
    , current_step_index(0)
    , next_step_index_needed(0)
    , desired_step_saturated(_alloc)  {
    }



   typedef uint32_t _status_flags_type;
  _status_flags_type status_flags;

   typedef double _t_step_rem_type;
  _t_step_rem_type t_step_rem;

   typedef uint32_t _current_step_index_type;
  _current_step_index_type current_step_index;

   typedef uint32_t _next_step_index_needed_type;
  _next_step_index_needed_type next_step_index_needed;

   typedef  ::atlas_msgs::AtlasBehaviorStepData_<ContainerAllocator>  _desired_step_saturated_type;
  _desired_step_saturated_type desired_step_saturated;


    enum { STEP_SUBSTATE_SWAYING = 0 };
     enum { STEP_SUBSTATE_STEPPING = 1 };
 

  typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct AtlasBehaviorStepFeedback_

typedef ::atlas_msgs::AtlasBehaviorStepFeedback_<std::allocator<void> > AtlasBehaviorStepFeedback;

typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorStepFeedback > AtlasBehaviorStepFeedbackPtr;
typedef boost::shared_ptr< ::atlas_msgs::AtlasBehaviorStepFeedback const> AtlasBehaviorStepFeedbackConstPtr;

// constants requiring out of line definition

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace atlas_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'atlas_msgs': ['/tmp/buildd/drcsim-3.2.0/atlas_msgs/msg', '/tmp/buildd/drcsim-3.2.0/obj-x86_64-linux-gnu/devel/share/atlas_msgs/msg'], 'sandia_hand_msgs': ['/opt/ros/groovy/share/sandia_hand_msgs/cmake/../msg'], 'osrf_msgs': ['/opt/ros/groovy/share/osrf_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'control_msgs': ['/opt/ros/groovy/share/control_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >
{
  static const char* value()
  {
    return "cff2fc0e568e03f6269567166d997b7c";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xcff2fc0e568e03f6ULL;
  static const uint64_t static_value2 = 0x269567166d997b7cULL;
};

template<class ContainerAllocator>
struct DataType< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >
{
  static const char* value()
  {
    return "atlas_msgs/AtlasBehaviorStepFeedback";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# mirrored from AtlasControlTypes.h\n\
uint32 STEP_SUBSTATE_SWAYING = 0  # Feet are in double support. This flag does not latch. Only one of STEP_SUBSTATE_SWAYING or STEP_SUBSTATE_STEPPING will be set at any given time.\n\
uint32 STEP_SUBSTATE_STEPPING = 1 # Actively stepping; one foot is in the air. This flag does not latch.\n\
\n\
uint32 status_flags    # use AtlasBeahviorFeedback/status_flags\n\
float64 t_step_rem\n\
uint32 current_step_index\n\
uint32 next_step_index_needed\n\
atlas_msgs/AtlasBehaviorStepData desired_step_saturated\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStepData\n\
# multi_step walking trajectory parameters\n\
uint32 step_index              # Step index, matlab style, starting from 1,\n\
                               # monotonically increasing during walking\n\
                               #  resets to 1 if robot leaves walk behaviors\n\
uint32 foot_index              # Foot_index can be LEFT_FOOT or RIGHT_FOOT\n\
float64 duration               # Step duration, when in doubt, 0.63s is a\n\
                               # good guess.\n\
geometry_msgs/Pose pose        # Foot pose in Atlas world frame\n\
float64 swing_height           # Step apex swing height measured form the\n\
                               # midpoint between the feet.\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
";
  }

  static const char* value(const ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.status_flags);
      stream.next(m.t_step_rem);
      stream.next(m.current_step_index);
      stream.next(m.next_step_index_needed);
      stream.next(m.desired_step_saturated);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct AtlasBehaviorStepFeedback_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator>& v)
  {
    s << indent << "status_flags: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.status_flags);
    s << indent << "t_step_rem: ";
    Printer<double>::stream(s, indent + "  ", v.t_step_rem);
    s << indent << "current_step_index: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.current_step_index);
    s << indent << "next_step_index_needed: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.next_step_index_needed);
    s << indent << "desired_step_saturated: ";
    s << std::endl;
    Printer< ::atlas_msgs::AtlasBehaviorStepData_<ContainerAllocator> >::stream(s, indent + "  ", v.desired_step_saturated);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ATLAS_MSGS_MESSAGE_ATLASBEHAVIORSTEPFEEDBACK_H
