/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/drcsim-3.2.0/atlas_msgs/srv/AtlasFilters.srv
 *
 */


#ifndef ATLAS_MSGS_MESSAGE_ATLASFILTERSREQUEST_H
#define ATLAS_MSGS_MESSAGE_ATLASFILTERSREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace atlas_msgs
{
template <class ContainerAllocator>
struct AtlasFiltersRequest_
{
  typedef AtlasFiltersRequest_<ContainerAllocator> Type;

  AtlasFiltersRequest_()
    : coef_a()
    , coef_b()
    , filter_velocity(false)
    , filter_position(false)  {
    }
  AtlasFiltersRequest_(const ContainerAllocator& _alloc)
    : coef_a(_alloc)
    , coef_b(_alloc)
    , filter_velocity(false)
    , filter_position(false)  {
    }



   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _coef_a_type;
  _coef_a_type coef_a;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _coef_b_type;
  _coef_b_type coef_b;

   typedef uint8_t _filter_velocity_type;
  _filter_velocity_type filter_velocity;

   typedef uint8_t _filter_position_type;
  _filter_position_type filter_position;




  typedef boost::shared_ptr< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct AtlasFiltersRequest_

typedef ::atlas_msgs::AtlasFiltersRequest_<std::allocator<void> > AtlasFiltersRequest;

typedef boost::shared_ptr< ::atlas_msgs::AtlasFiltersRequest > AtlasFiltersRequestPtr;
typedef boost::shared_ptr< ::atlas_msgs::AtlasFiltersRequest const> AtlasFiltersRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace atlas_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'atlas_msgs': ['/tmp/buildd/drcsim-3.2.0/atlas_msgs/msg', '/tmp/buildd/drcsim-3.2.0/obj-x86_64-linux-gnu/devel/share/atlas_msgs/msg'], 'sandia_hand_msgs': ['/opt/ros/groovy/share/sandia_hand_msgs/cmake/../msg'], 'osrf_msgs': ['/opt/ros/groovy/share/osrf_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'control_msgs': ['/opt/ros/groovy/share/control_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "271d7f8e4a68b57888389ab6ce3a31b9";
  }

  static const char* value(const ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x271d7f8e4a68b578ULL;
  static const uint64_t static_value2 = 0x88389ab6ce3a31b9ULL;
};

template<class ContainerAllocator>
struct DataType< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "atlas_msgs/AtlasFiltersRequest";
  }

  static const char* value(const ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
float64[] coef_a\n\
\n\
\n\
float64[] coef_b\n\
\n\
\n\
\n\
bool filter_velocity\n\
bool filter_position\n\
\n\
\n\
";
  }

  static const char* value(const ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.coef_a);
      stream.next(m.coef_b);
      stream.next(m.filter_velocity);
      stream.next(m.filter_position);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct AtlasFiltersRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::atlas_msgs::AtlasFiltersRequest_<ContainerAllocator>& v)
  {
    s << indent << "coef_a[]" << std::endl;
    for (size_t i = 0; i < v.coef_a.size(); ++i)
    {
      s << indent << "  coef_a[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.coef_a[i]);
    }
    s << indent << "coef_b[]" << std::endl;
    for (size_t i = 0; i < v.coef_b.size(); ++i)
    {
      s << indent << "  coef_b[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.coef_b[i]);
    }
    s << indent << "filter_velocity: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.filter_velocity);
    s << indent << "filter_position: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.filter_position);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ATLAS_MSGS_MESSAGE_ATLASFILTERSREQUEST_H
