/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/drcsim-3.2.0/atlas_msgs/msg/AtlasSimInterfaceState.msg
 *
 */


#ifndef ATLAS_MSGS_MESSAGE_ATLASSIMINTERFACESTATE_H
#define ATLAS_MSGS_MESSAGE_ATLASSIMINTERFACESTATE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <atlas_msgs/AtlasPositionData.h>
#include <geometry_msgs/Pose.h>
#include <atlas_msgs/AtlasBehaviorFeedback.h>
#include <atlas_msgs/AtlasBehaviorStepFeedback.h>
#include <atlas_msgs/AtlasBehaviorStandFeedback.h>
#include <atlas_msgs/AtlasBehaviorWalkFeedback.h>
#include <atlas_msgs/AtlasBehaviorManipulateFeedback.h>

namespace atlas_msgs
{
template <class ContainerAllocator>
struct AtlasSimInterfaceState_
{
  typedef AtlasSimInterfaceState_<ContainerAllocator> Type;

  AtlasSimInterfaceState_()
    : header()
    , error_code(0)
    , current_behavior(0)
    , desired_behavior(0)
    , f_out()
    , pos_est()
    , foot_pos_est()
    , behavior_feedback()
    , step_feedback()
    , stand_feedback()
    , walk_feedback()
    , manipulate_feedback()
    , k_effort()  {
      f_out.assign(0.0);
  }
  AtlasSimInterfaceState_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , error_code(0)
    , current_behavior(0)
    , desired_behavior(0)
    , f_out()
    , pos_est(_alloc)
    , foot_pos_est()
    , behavior_feedback(_alloc)
    , step_feedback(_alloc)
    , stand_feedback(_alloc)
    , walk_feedback(_alloc)
    , manipulate_feedback(_alloc)
    , k_effort(_alloc)  {
      f_out.assign(0.0);

      foot_pos_est.assign( ::geometry_msgs::Pose_<ContainerAllocator> (_alloc));
  }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef int32_t _error_code_type;
  _error_code_type error_code;

   typedef int32_t _current_behavior_type;
  _current_behavior_type current_behavior;

   typedef int32_t _desired_behavior_type;
  _desired_behavior_type desired_behavior;

   typedef boost::array<double, 28>  _f_out_type;
  _f_out_type f_out;

   typedef  ::atlas_msgs::AtlasPositionData_<ContainerAllocator>  _pos_est_type;
  _pos_est_type pos_est;

   typedef boost::array< ::geometry_msgs::Pose_<ContainerAllocator> , 2>  _foot_pos_est_type;
  _foot_pos_est_type foot_pos_est;

   typedef  ::atlas_msgs::AtlasBehaviorFeedback_<ContainerAllocator>  _behavior_feedback_type;
  _behavior_feedback_type behavior_feedback;

   typedef  ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator>  _step_feedback_type;
  _step_feedback_type step_feedback;

   typedef  ::atlas_msgs::AtlasBehaviorStandFeedback_<ContainerAllocator>  _stand_feedback_type;
  _stand_feedback_type stand_feedback;

   typedef  ::atlas_msgs::AtlasBehaviorWalkFeedback_<ContainerAllocator>  _walk_feedback_type;
  _walk_feedback_type walk_feedback;

   typedef  ::atlas_msgs::AtlasBehaviorManipulateFeedback_<ContainerAllocator>  _manipulate_feedback_type;
  _manipulate_feedback_type manipulate_feedback;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _k_effort_type;
  _k_effort_type k_effort;


    enum { NO_ERRORS = 0 };
     enum { ERROR_UNSPECIFIED = -1 };
     enum { ERROR_VALUE_OUT_OF_RANGE = -2 };
     enum { ERROR_INVALID_INDEX = -3 };
     enum { ERROR_FAILED_TO_START_BEHAVIOR = -4 };
     enum { ERROR_NO_ACTIVE_BEHAVIOR = -5 };
     enum { ERROR_NO_SUCH_BEHAVIOR = -6 };
     enum { ERROR_BEHAVIOR_NOT_IMPLEMENTED = -7 };
     enum { ERROR_TIME_RAN_BACKWARD = -8 };
 

  typedef boost::shared_ptr< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct AtlasSimInterfaceState_

typedef ::atlas_msgs::AtlasSimInterfaceState_<std::allocator<void> > AtlasSimInterfaceState;

typedef boost::shared_ptr< ::atlas_msgs::AtlasSimInterfaceState > AtlasSimInterfaceStatePtr;
typedef boost::shared_ptr< ::atlas_msgs::AtlasSimInterfaceState const> AtlasSimInterfaceStateConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace atlas_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'atlas_msgs': ['/tmp/buildd/drcsim-3.2.0/atlas_msgs/msg', '/tmp/buildd/drcsim-3.2.0/obj-x86_64-linux-gnu/devel/share/atlas_msgs/msg'], 'sandia_hand_msgs': ['/opt/ros/groovy/share/sandia_hand_msgs/cmake/../msg'], 'osrf_msgs': ['/opt/ros/groovy/share/osrf_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'control_msgs': ['/opt/ros/groovy/share/control_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "cac8848356ecf29db9175b861bbf8e75";
  }

  static const char* value(const ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xcac8848356ecf29dULL;
  static const uint64_t static_value2 = 0xb9175b861bbf8e75ULL;
};

template<class ContainerAllocator>
struct DataType< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "atlas_msgs/AtlasSimInterfaceState";
  }

  static const char* value(const ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# For interfacing Boston Dynamics' AtlasSimInterface Dynamics Behavior Library\n\
# Feedback from AtlasSimInterface Controller after calling process_control_input\n\
# This ROS message should track AtlasControlOutput struct in\n\
# AtlasSimInterfaceTypes.h.\n\
# With the exception of addition of k_effort to provide user a way to switch\n\
# to/from PID servo control in AtlasPlugin.cpp on a per joint basis.\n\
\n\
int32 NO_ERRORS                        =  0    # no error detected\n\
int32 ERROR_UNSPECIFIED                = -1    # unspecified error\n\
int32 ERROR_VALUE_OUT_OF_RANGE         = -2    # passed value is out of range\n\
int32 ERROR_INVALID_INDEX              = -3    # passed index is invalid (too low or too high)\n\
int32 ERROR_FAILED_TO_START_BEHAVIOR   = -4    # robot failed to start desired behavior\n\
int32 ERROR_NO_ACTIVE_BEHAVIOR         = -5    # robot has no active behavior\n\
int32 ERROR_NO_SUCH_BEHAVIOR           = -6    # behavior doesn't exist\n\
int32 ERROR_BEHAVIOR_NOT_IMPLEMENTED   = -7    # behavior exists but not implemented\n\
int32 ERROR_TIME_RAN_BACKWARD          = -8    # a time earlier than previous times was given\n\
\n\
Header header\n\
\n\
int32 error_code                         # error code returned by\n\
                                         # process_control_input.\n\
                                         # See AtlasSimInterfaceTypes.h\n\
                                         # AtlasErrorCode for list of enums.\n\
                                         # The list is mimic'd here above.\n\
\n\
int32 current_behavior                   # current active behavior.\n\
int32 desired_behavior                   # desired behavior specified by usesr\n\
                                         # input. This may lag from\n\
                                         # current_behavior by a few simulation\n\
                                         # steps.\n\
\n\
# below are information from AtlasControlOutput in AtlasSimInterfaceTypes.h\n\
\n\
float64[28] f_out                        # torque command from BDI controller.\n\
\n\
atlas_msgs/AtlasPositionData pos_est     # Position and velocity estimate of robot pelvis\n\
\n\
geometry_msgs/Pose[2] foot_pos_est      # World position estimate for feet\n\
                                         # 0 - left, 1 - right\n\
\n\
atlas_msgs/AtlasBehaviorFeedback behavior_feedback\n\
atlas_msgs/AtlasBehaviorStepFeedback step_feedback\n\
atlas_msgs/AtlasBehaviorStandFeedback stand_feedback\n\
atlas_msgs/AtlasBehaviorWalkFeedback walk_feedback\n\
atlas_msgs/AtlasBehaviorManipulateFeedback manipulate_feedback\n\
\n\
# additional vector for transitioning from servo model in AtlasPlugin\n\
# to BDI servo.\n\
\n\
uint8[] k_effort       # k_effort can be an unsigned int 8value from 0 to 255, \n\
                       # at run time, a double between 0 and 1 is obtained\n\
                       # by dividing by 255.0d.\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasPositionData\n\
# mirrors AtlasPositionData in AtlasControlTypes.h\n\
geometry_msgs/Vector3 position\n\
geometry_msgs/Vector3 velocity\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorFeedback\n\
# mirrors AtlasBehaviorFeedback\n\
#\n\
# Transition flags:\n\
#    - STATUS_TRANSITION_IN_PROGRESS\n\
#\n\
#        A transition is in progress.\n\
#\n\
#    - STATUS_TRANSITION_SUCCESS\n\
#\n\
#        Successful transition.\n\
#\n\
#    - STATUS_FAILED_TRANS_UNKNOWN_BEHAVIOR\n\
#\n\
#        Failed to transition; unknown behavior.\n\
#\n\
#    - STATUS_FAILED_TRANS_ILLEGAL_BEHAVIOR\n\
#\n\
#        Denied request for an illegal behavior transition.  This may\n\
#        happen if a transition to a new behavior is requested without\n\
#        going through a required intermediate behavior. (e.g., can't\n\
#        go from Walk straight to Manipulate.)\n\
#\n\
#    - STATUS_FAILED_TRANS_COM_POS\n\
#\n\
#        Failed to transition; the position of the COM is too far from\n\
#        the center of support.\n\
#\n\
#    - STATUS_FAILED_TRANS_COM_VEL\n\
#\n\
#        Failed to transition; the COM velocity too high.\n\
#\n\
#    - STATUS_FAILED_TRANS_VEL\n\
#\n\
#        Failed to transition; some joint velocities too high.\n\
#\n\
#  \\em Warnings:\n\
#\n\
#    - STATUS_WARNING_AUTO_TRANS\n\
#\n\
#        An automatic transition occurred; see behavior specific\n\
#        feedback for reason.\n\
#\n\
#  \\em Errors:\n\
#\n\
#    - STATUS_ERROR_FALLING\n\
#\n\
#        COM below acceptable threshold, cannot recover.\n\
\n\
# copied from AtlasBehaviorFlags\n\
uint32 STATUS_OK                            = 0\n\
uint32 STATUS_TRANSITION_IN_PROGRESS        = 1\n\
uint32 STATUS_TRANSITION_SUCCESS            = 2\n\
uint32 STATUS_FAILED_TRANS_UNKNOWN_BEHAVIOR = 4\n\
uint32 STATUS_FAILED_TRANS_ILLEGAL_BEHAVIOR = 8\n\
uint32 STATUS_FAILED_TRANS_COM_POS          = 16\n\
uint32 STATUS_FAILED_TRANS_COM_VEL          = 32\n\
uint32 STATUS_FAILED_TRANS_VEL              = 64\n\
uint32 STATUS_WARNING_AUTO_TRANS            = 128\n\
uint32 STATUS_ERROR_FALLING                 = 256\n\
\n\
uint32 status_flags  # can be one of above\n\
\n\
int32 trans_from_behavior_index  # use this as a parm to get_behavior_at_index() to get behavior string\n\
int32 trans_to_behavior_index  # use this as a parm to get_behavior_at_index() to get behavior string\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStepFeedback\n\
# mirrored from AtlasControlTypes.h\n\
uint32 STEP_SUBSTATE_SWAYING = 0  # Feet are in double support. This flag does not latch. Only one of STEP_SUBSTATE_SWAYING or STEP_SUBSTATE_STEPPING will be set at any given time.\n\
uint32 STEP_SUBSTATE_STEPPING = 1 # Actively stepping; one foot is in the air. This flag does not latch.\n\
\n\
uint32 status_flags    # use AtlasBeahviorFeedback/status_flags\n\
float64 t_step_rem\n\
uint32 current_step_index\n\
uint32 next_step_index_needed\n\
atlas_msgs/AtlasBehaviorStepData desired_step_saturated\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStepData\n\
# multi_step walking trajectory parameters\n\
uint32 step_index              # Step index, matlab style, starting from 1,\n\
                               # monotonically increasing during walking\n\
                               #  resets to 1 if robot leaves walk behaviors\n\
uint32 foot_index              # Foot_index can be LEFT_FOOT or RIGHT_FOOT\n\
float64 duration               # Step duration, when in doubt, 0.63s is a\n\
                               # good guess.\n\
geometry_msgs/Pose pose        # Foot pose in Atlas world frame\n\
float64 swing_height           # Step apex swing height measured form the\n\
                               # midpoint between the feet.\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStandFeedback\n\
# mirrored from AtlasControlTypes.h\n\
uint32 status_flags    # use AtlasBeahviorStandFlags\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorWalkFeedback\n\
# mirrored from AtlasControlTypes.h\n\
float64 t_step_rem\n\
uint32 current_step_index\n\
uint32 next_step_index_needed\n\
uint32 status_flags    # use AtlasBeahviorFeedback/status_flags\n\
atlas_msgs/AtlasBehaviorStepData[4] step_queue_saturated # 4 is hardcoded in AtlasSimInterface library.\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorManipulateFeedback\n\
# mirrored from AtlasControlTypes.h\n\
uint32 status_flags    # use AtlasBeahviorManipulateFlags\n\
atlas_msgs/AtlasBehaviorPelvisServoParams clamped\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorPelvisServoParams\n\
# mirrored from AtlasControlTypes.h\n\
\n\
float64 pelvis_height\n\
float64 pelvis_yaw\n\
float64 pelvis_lat\n\
\n\
";
  }

  static const char* value(const ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.error_code);
      stream.next(m.current_behavior);
      stream.next(m.desired_behavior);
      stream.next(m.f_out);
      stream.next(m.pos_est);
      stream.next(m.foot_pos_est);
      stream.next(m.behavior_feedback);
      stream.next(m.step_feedback);
      stream.next(m.stand_feedback);
      stream.next(m.walk_feedback);
      stream.next(m.manipulate_feedback);
      stream.next(m.k_effort);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct AtlasSimInterfaceState_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::atlas_msgs::AtlasSimInterfaceState_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "error_code: ";
    Printer<int32_t>::stream(s, indent + "  ", v.error_code);
    s << indent << "current_behavior: ";
    Printer<int32_t>::stream(s, indent + "  ", v.current_behavior);
    s << indent << "desired_behavior: ";
    Printer<int32_t>::stream(s, indent + "  ", v.desired_behavior);
    s << indent << "f_out[]" << std::endl;
    for (size_t i = 0; i < v.f_out.size(); ++i)
    {
      s << indent << "  f_out[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.f_out[i]);
    }
    s << indent << "pos_est: ";
    s << std::endl;
    Printer< ::atlas_msgs::AtlasPositionData_<ContainerAllocator> >::stream(s, indent + "  ", v.pos_est);
    s << indent << "foot_pos_est[]" << std::endl;
    for (size_t i = 0; i < v.foot_pos_est.size(); ++i)
    {
      s << indent << "  foot_pos_est[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "    ", v.foot_pos_est[i]);
    }
    s << indent << "behavior_feedback: ";
    s << std::endl;
    Printer< ::atlas_msgs::AtlasBehaviorFeedback_<ContainerAllocator> >::stream(s, indent + "  ", v.behavior_feedback);
    s << indent << "step_feedback: ";
    s << std::endl;
    Printer< ::atlas_msgs::AtlasBehaviorStepFeedback_<ContainerAllocator> >::stream(s, indent + "  ", v.step_feedback);
    s << indent << "stand_feedback: ";
    s << std::endl;
    Printer< ::atlas_msgs::AtlasBehaviorStandFeedback_<ContainerAllocator> >::stream(s, indent + "  ", v.stand_feedback);
    s << indent << "walk_feedback: ";
    s << std::endl;
    Printer< ::atlas_msgs::AtlasBehaviorWalkFeedback_<ContainerAllocator> >::stream(s, indent + "  ", v.walk_feedback);
    s << indent << "manipulate_feedback: ";
    s << std::endl;
    Printer< ::atlas_msgs::AtlasBehaviorManipulateFeedback_<ContainerAllocator> >::stream(s, indent + "  ", v.manipulate_feedback);
    s << indent << "k_effort[]" << std::endl;
    for (size_t i = 0; i < v.k_effort.size(); ++i)
    {
      s << indent << "  k_effort[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.k_effort[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ATLAS_MSGS_MESSAGE_ATLASSIMINTERFACESTATE_H
