/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/drcsim-3.2.0/atlas_msgs/msg/ControllerStatistics.msg
 *
 */


#ifndef ATLAS_MSGS_MESSAGE_CONTROLLERSTATISTICS_H
#define ATLAS_MSGS_MESSAGE_CONTROLLERSTATISTICS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace atlas_msgs
{
template <class ContainerAllocator>
struct ControllerStatistics_
{
  typedef ControllerStatistics_<ContainerAllocator> Type;

  ControllerStatistics_()
    : header()
    , command_age(0.0)
    , command_age_mean(0.0)
    , command_age_variance(0.0)
    , command_age_window_size(0.0)  {
    }
  ControllerStatistics_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , command_age(0.0)
    , command_age_mean(0.0)
    , command_age_variance(0.0)
    , command_age_window_size(0.0)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef double _command_age_type;
  _command_age_type command_age;

   typedef double _command_age_mean_type;
  _command_age_mean_type command_age_mean;

   typedef double _command_age_variance_type;
  _command_age_variance_type command_age_variance;

   typedef double _command_age_window_size_type;
  _command_age_window_size_type command_age_window_size;




  typedef boost::shared_ptr< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ControllerStatistics_

typedef ::atlas_msgs::ControllerStatistics_<std::allocator<void> > ControllerStatistics;

typedef boost::shared_ptr< ::atlas_msgs::ControllerStatistics > ControllerStatisticsPtr;
typedef boost::shared_ptr< ::atlas_msgs::ControllerStatistics const> ControllerStatisticsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::atlas_msgs::ControllerStatistics_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace atlas_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'atlas_msgs': ['/tmp/buildd/drcsim-3.2.0/atlas_msgs/msg', '/tmp/buildd/drcsim-3.2.0/obj-x86_64-linux-gnu/devel/share/atlas_msgs/msg'], 'sandia_hand_msgs': ['/opt/ros/groovy/share/sandia_hand_msgs/cmake/../msg'], 'osrf_msgs': ['/opt/ros/groovy/share/osrf_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'control_msgs': ['/opt/ros/groovy/share/control_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >
{
  static const char* value()
  {
    return "628a0c6643f9fd5708402f085735e478";
  }

  static const char* value(const ::atlas_msgs::ControllerStatistics_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x628a0c6643f9fd57ULL;
  static const uint64_t static_value2 = 0x08402f085735e478ULL;
};

template<class ContainerAllocator>
struct DataType< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >
{
  static const char* value()
  {
    return "atlas_msgs/ControllerStatistics";
  }

  static const char* value(const ::atlas_msgs::ControllerStatistics_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Keep track of Atlas controller statistics over ros topic\n\
Header header\n\
float64 command_age\n\
float64 command_age_mean\n\
float64 command_age_variance\n\
float64 command_age_window_size\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
";
  }

  static const char* value(const ::atlas_msgs::ControllerStatistics_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.command_age);
      stream.next(m.command_age_mean);
      stream.next(m.command_age_variance);
      stream.next(m.command_age_window_size);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ControllerStatistics_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::atlas_msgs::ControllerStatistics_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::atlas_msgs::ControllerStatistics_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "command_age: ";
    Printer<double>::stream(s, indent + "  ", v.command_age);
    s << indent << "command_age_mean: ";
    Printer<double>::stream(s, indent + "  ", v.command_age_mean);
    s << indent << "command_age_variance: ";
    Printer<double>::stream(s, indent + "  ", v.command_age_variance);
    s << indent << "command_age_window_size: ";
    Printer<double>::stream(s, indent + "  ", v.command_age_window_size);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ATLAS_MSGS_MESSAGE_CONTROLLERSTATISTICS_H
