/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/drcsim-3.2.0/obj-x86_64-linux-gnu/devel/share/atlas_msgs/msg/WalkDemoAction.msg
 *
 */


#ifndef ATLAS_MSGS_MESSAGE_WALKDEMOACTION_H
#define ATLAS_MSGS_MESSAGE_WALKDEMOACTION_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <atlas_msgs/WalkDemoActionGoal.h>
#include <atlas_msgs/WalkDemoActionResult.h>
#include <atlas_msgs/WalkDemoActionFeedback.h>

namespace atlas_msgs
{
template <class ContainerAllocator>
struct WalkDemoAction_
{
  typedef WalkDemoAction_<ContainerAllocator> Type;

  WalkDemoAction_()
    : action_goal()
    , action_result()
    , action_feedback()  {
    }
  WalkDemoAction_(const ContainerAllocator& _alloc)
    : action_goal(_alloc)
    , action_result(_alloc)
    , action_feedback(_alloc)  {
    }



   typedef  ::atlas_msgs::WalkDemoActionGoal_<ContainerAllocator>  _action_goal_type;
  _action_goal_type action_goal;

   typedef  ::atlas_msgs::WalkDemoActionResult_<ContainerAllocator>  _action_result_type;
  _action_result_type action_result;

   typedef  ::atlas_msgs::WalkDemoActionFeedback_<ContainerAllocator>  _action_feedback_type;
  _action_feedback_type action_feedback;




  typedef boost::shared_ptr< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct WalkDemoAction_

typedef ::atlas_msgs::WalkDemoAction_<std::allocator<void> > WalkDemoAction;

typedef boost::shared_ptr< ::atlas_msgs::WalkDemoAction > WalkDemoActionPtr;
typedef boost::shared_ptr< ::atlas_msgs::WalkDemoAction const> WalkDemoActionConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::atlas_msgs::WalkDemoAction_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace atlas_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'atlas_msgs': ['/tmp/buildd/drcsim-3.2.0/atlas_msgs/msg', '/tmp/buildd/drcsim-3.2.0/obj-x86_64-linux-gnu/devel/share/atlas_msgs/msg'], 'sandia_hand_msgs': ['/opt/ros/groovy/share/sandia_hand_msgs/cmake/../msg'], 'osrf_msgs': ['/opt/ros/groovy/share/osrf_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'control_msgs': ['/opt/ros/groovy/share/control_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "abe30eb264997de30b2841a700221184";
  }

  static const char* value(const ::atlas_msgs::WalkDemoAction_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xabe30eb264997de3ULL;
  static const uint64_t static_value2 = 0x0b2841a700221184ULL;
};

template<class ContainerAllocator>
struct DataType< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "atlas_msgs/WalkDemoAction";
  }

  static const char* value(const ::atlas_msgs::WalkDemoAction_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
\n\
WalkDemoActionGoal action_goal\n\
WalkDemoActionResult action_result\n\
WalkDemoActionFeedback action_feedback\n\
\n\
================================================================================\n\
MSG: atlas_msgs/WalkDemoActionGoal\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
\n\
Header header\n\
actionlib_msgs/GoalID goal_id\n\
WalkDemoGoal goal\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: actionlib_msgs/GoalID\n\
# The stamp should store the time at which this goal was requested.\n\
# It is used by an action server when it tries to preempt all\n\
# goals that were requested before a certain time\n\
time stamp\n\
\n\
# The id provides a way to associate feedback and\n\
# result message with specific goal requests. The id\n\
# specified must be unique.\n\
string id\n\
\n\
\n\
================================================================================\n\
MSG: atlas_msgs/WalkDemoGoal\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# Goal\n\
# For Setting MultiStep Walking Commands\n\
Header header\n\
\n\
# permissible values for behavior\n\
int32 STAND             =  0 # stand\n\
int32 USER              =  1 # disable AtlasSimInterface updates, rely on\n\
                             # /atlas/atlas_command or /atlas/joint_commands\n\
int32 FREEZE            =  2 # safety mode\n\
int32 STAND_PREP        =  3 # stand-prep (AtlasSimInterface documentation)\n\
int32 WALK              =  4 # multi-step walk\n\
int32 STEP              =  5 # single step walk\n\
int32 MANIPULATE        =  6 # stand and allows manipulation.\n\
\n\
int32 behavior                # can be one of\n\
                              # USER, FREEZE, STAND_PREP\n\
                              # WALK, STEP, STAND, MANIPULATE\n\
                              # DEMO1, DEMO2\n\
\n\
# multi_step walking trajectory parameters\n\
atlas_msgs/AtlasBehaviorStepData[] steps\n\
\n\
# parameters for single_step behavior\n\
atlas_msgs/AtlasBehaviorStepParams step_params\n\
\n\
# parameters for standing behavior\n\
atlas_msgs/AtlasBehaviorStandParams stand_params\n\
\n\
# parameters for stand and manipulate\n\
atlas_msgs/AtlasBehaviorManipulateParams manipulate_params\n\
\n\
# same k_effort as AtlasCommand\n\
uint8[] k_effort       # k_effort can be an unsigned int 8value from 0 to 255, \n\
                       # at run time, a double between 0 and 1 is obtained\n\
                       # by dividing by 255.0d.\n\
\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStepData\n\
# multi_step walking trajectory parameters\n\
uint32 step_index              # Step index, matlab style, starting from 1,\n\
                               # monotonically increasing during walking\n\
                               #  resets to 1 if robot leaves walk behaviors\n\
uint32 foot_index              # Foot_index can be LEFT_FOOT or RIGHT_FOOT\n\
float64 duration               # Step duration, when in doubt, 0.63s is a\n\
                               # good guess.\n\
geometry_msgs/Pose pose        # Foot pose in Atlas world frame\n\
float64 swing_height           # Step apex swing height measured form the\n\
                               # midpoint between the feet.\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStepParams\n\
# parameters for single_step behavior\n\
atlas_msgs/AtlasBehaviorStepData desired_step\n\
bool use_demo_walk\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStandParams\n\
# stand parameters\n\
int32 placeholder\n\
# etc., more to come\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorManipulateParams\n\
# mirrored from AtlasControlTypes.h\n\
bool use_desired\n\
atlas_msgs/AtlasBehaviorPelvisServoParams desired\n\
bool use_demo_mode\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorPelvisServoParams\n\
# mirrored from AtlasControlTypes.h\n\
\n\
float64 pelvis_height\n\
float64 pelvis_yaw\n\
float64 pelvis_lat\n\
\n\
================================================================================\n\
MSG: atlas_msgs/WalkDemoActionResult\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
\n\
Header header\n\
actionlib_msgs/GoalStatus status\n\
WalkDemoResult result\n\
\n\
================================================================================\n\
MSG: actionlib_msgs/GoalStatus\n\
GoalID goal_id\n\
uint8 status\n\
uint8 PENDING         = 0   # The goal has yet to be processed by the action server\n\
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server\n\
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing\n\
                            #   and has since completed its execution (Terminal State)\n\
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)\n\
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due\n\
                            #    to some failure (Terminal State)\n\
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,\n\
                            #    because the goal was unattainable or invalid (Terminal State)\n\
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing\n\
                            #    and has not yet completed execution\n\
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,\n\
                            #    but the action server has not yet confirmed that the goal is canceled\n\
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing\n\
                            #    and was successfully cancelled (Terminal State)\n\
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be\n\
                            #    sent over the wire by an action server\n\
\n\
#Allow for the user to associate a string with GoalStatus for debugging\n\
string text\n\
\n\
\n\
================================================================================\n\
MSG: atlas_msgs/WalkDemoResult\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# Result\n\
atlas_msgs/AtlasSimInterfaceState end_state\n\
bool success\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasSimInterfaceState\n\
# For interfacing Boston Dynamics' AtlasSimInterface Dynamics Behavior Library\n\
# Feedback from AtlasSimInterface Controller after calling process_control_input\n\
# This ROS message should track AtlasControlOutput struct in\n\
# AtlasSimInterfaceTypes.h.\n\
# With the exception of addition of k_effort to provide user a way to switch\n\
# to/from PID servo control in AtlasPlugin.cpp on a per joint basis.\n\
\n\
int32 NO_ERRORS                        =  0    # no error detected\n\
int32 ERROR_UNSPECIFIED                = -1    # unspecified error\n\
int32 ERROR_VALUE_OUT_OF_RANGE         = -2    # passed value is out of range\n\
int32 ERROR_INVALID_INDEX              = -3    # passed index is invalid (too low or too high)\n\
int32 ERROR_FAILED_TO_START_BEHAVIOR   = -4    # robot failed to start desired behavior\n\
int32 ERROR_NO_ACTIVE_BEHAVIOR         = -5    # robot has no active behavior\n\
int32 ERROR_NO_SUCH_BEHAVIOR           = -6    # behavior doesn't exist\n\
int32 ERROR_BEHAVIOR_NOT_IMPLEMENTED   = -7    # behavior exists but not implemented\n\
int32 ERROR_TIME_RAN_BACKWARD          = -8    # a time earlier than previous times was given\n\
\n\
Header header\n\
\n\
int32 error_code                         # error code returned by\n\
                                         # process_control_input.\n\
                                         # See AtlasSimInterfaceTypes.h\n\
                                         # AtlasErrorCode for list of enums.\n\
                                         # The list is mimic'd here above.\n\
\n\
int32 current_behavior                   # current active behavior.\n\
int32 desired_behavior                   # desired behavior specified by usesr\n\
                                         # input. This may lag from\n\
                                         # current_behavior by a few simulation\n\
                                         # steps.\n\
\n\
# below are information from AtlasControlOutput in AtlasSimInterfaceTypes.h\n\
\n\
float64[28] f_out                        # torque command from BDI controller.\n\
\n\
atlas_msgs/AtlasPositionData pos_est     # Position and velocity estimate of robot pelvis\n\
\n\
geometry_msgs/Pose[2] foot_pos_est      # World position estimate for feet\n\
                                         # 0 - left, 1 - right\n\
\n\
atlas_msgs/AtlasBehaviorFeedback behavior_feedback\n\
atlas_msgs/AtlasBehaviorStepFeedback step_feedback\n\
atlas_msgs/AtlasBehaviorStandFeedback stand_feedback\n\
atlas_msgs/AtlasBehaviorWalkFeedback walk_feedback\n\
atlas_msgs/AtlasBehaviorManipulateFeedback manipulate_feedback\n\
\n\
# additional vector for transitioning from servo model in AtlasPlugin\n\
# to BDI servo.\n\
\n\
uint8[] k_effort       # k_effort can be an unsigned int 8value from 0 to 255, \n\
                       # at run time, a double between 0 and 1 is obtained\n\
                       # by dividing by 255.0d.\n\
\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasPositionData\n\
# mirrors AtlasPositionData in AtlasControlTypes.h\n\
geometry_msgs/Vector3 position\n\
geometry_msgs/Vector3 velocity\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorFeedback\n\
# mirrors AtlasBehaviorFeedback\n\
#\n\
# Transition flags:\n\
#    - STATUS_TRANSITION_IN_PROGRESS\n\
#\n\
#        A transition is in progress.\n\
#\n\
#    - STATUS_TRANSITION_SUCCESS\n\
#\n\
#        Successful transition.\n\
#\n\
#    - STATUS_FAILED_TRANS_UNKNOWN_BEHAVIOR\n\
#\n\
#        Failed to transition; unknown behavior.\n\
#\n\
#    - STATUS_FAILED_TRANS_ILLEGAL_BEHAVIOR\n\
#\n\
#        Denied request for an illegal behavior transition.  This may\n\
#        happen if a transition to a new behavior is requested without\n\
#        going through a required intermediate behavior. (e.g., can't\n\
#        go from Walk straight to Manipulate.)\n\
#\n\
#    - STATUS_FAILED_TRANS_COM_POS\n\
#\n\
#        Failed to transition; the position of the COM is too far from\n\
#        the center of support.\n\
#\n\
#    - STATUS_FAILED_TRANS_COM_VEL\n\
#\n\
#        Failed to transition; the COM velocity too high.\n\
#\n\
#    - STATUS_FAILED_TRANS_VEL\n\
#\n\
#        Failed to transition; some joint velocities too high.\n\
#\n\
#  \\em Warnings:\n\
#\n\
#    - STATUS_WARNING_AUTO_TRANS\n\
#\n\
#        An automatic transition occurred; see behavior specific\n\
#        feedback for reason.\n\
#\n\
#  \\em Errors:\n\
#\n\
#    - STATUS_ERROR_FALLING\n\
#\n\
#        COM below acceptable threshold, cannot recover.\n\
\n\
# copied from AtlasBehaviorFlags\n\
uint32 STATUS_OK                            = 0\n\
uint32 STATUS_TRANSITION_IN_PROGRESS        = 1\n\
uint32 STATUS_TRANSITION_SUCCESS            = 2\n\
uint32 STATUS_FAILED_TRANS_UNKNOWN_BEHAVIOR = 4\n\
uint32 STATUS_FAILED_TRANS_ILLEGAL_BEHAVIOR = 8\n\
uint32 STATUS_FAILED_TRANS_COM_POS          = 16\n\
uint32 STATUS_FAILED_TRANS_COM_VEL          = 32\n\
uint32 STATUS_FAILED_TRANS_VEL              = 64\n\
uint32 STATUS_WARNING_AUTO_TRANS            = 128\n\
uint32 STATUS_ERROR_FALLING                 = 256\n\
\n\
uint32 status_flags  # can be one of above\n\
\n\
int32 trans_from_behavior_index  # use this as a parm to get_behavior_at_index() to get behavior string\n\
int32 trans_to_behavior_index  # use this as a parm to get_behavior_at_index() to get behavior string\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStepFeedback\n\
# mirrored from AtlasControlTypes.h\n\
uint32 STEP_SUBSTATE_SWAYING = 0  # Feet are in double support. This flag does not latch. Only one of STEP_SUBSTATE_SWAYING or STEP_SUBSTATE_STEPPING will be set at any given time.\n\
uint32 STEP_SUBSTATE_STEPPING = 1 # Actively stepping; one foot is in the air. This flag does not latch.\n\
\n\
uint32 status_flags    # use AtlasBeahviorFeedback/status_flags\n\
float64 t_step_rem\n\
uint32 current_step_index\n\
uint32 next_step_index_needed\n\
atlas_msgs/AtlasBehaviorStepData desired_step_saturated\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorStandFeedback\n\
# mirrored from AtlasControlTypes.h\n\
uint32 status_flags    # use AtlasBeahviorStandFlags\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorWalkFeedback\n\
# mirrored from AtlasControlTypes.h\n\
float64 t_step_rem\n\
uint32 current_step_index\n\
uint32 next_step_index_needed\n\
uint32 status_flags    # use AtlasBeahviorFeedback/status_flags\n\
atlas_msgs/AtlasBehaviorStepData[4] step_queue_saturated # 4 is hardcoded in AtlasSimInterface library.\n\
\n\
================================================================================\n\
MSG: atlas_msgs/AtlasBehaviorManipulateFeedback\n\
# mirrored from AtlasControlTypes.h\n\
uint32 status_flags    # use AtlasBeahviorManipulateFlags\n\
atlas_msgs/AtlasBehaviorPelvisServoParams clamped\n\
\n\
================================================================================\n\
MSG: atlas_msgs/WalkDemoActionFeedback\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
\n\
Header header\n\
actionlib_msgs/GoalStatus status\n\
WalkDemoFeedback feedback\n\
\n\
================================================================================\n\
MSG: atlas_msgs/WalkDemoFeedback\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# Feedback\n\
atlas_msgs/AtlasSimInterfaceState state\n\
\n\
\n\
";
  }

  static const char* value(const ::atlas_msgs::WalkDemoAction_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.action_goal);
      stream.next(m.action_result);
      stream.next(m.action_feedback);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct WalkDemoAction_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::atlas_msgs::WalkDemoAction_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::atlas_msgs::WalkDemoAction_<ContainerAllocator>& v)
  {
    s << indent << "action_goal: ";
    s << std::endl;
    Printer< ::atlas_msgs::WalkDemoActionGoal_<ContainerAllocator> >::stream(s, indent + "  ", v.action_goal);
    s << indent << "action_result: ";
    s << std::endl;
    Printer< ::atlas_msgs::WalkDemoActionResult_<ContainerAllocator> >::stream(s, indent + "  ", v.action_result);
    s << indent << "action_feedback: ";
    s << std::endl;
    Printer< ::atlas_msgs::WalkDemoActionFeedback_<ContainerAllocator> >::stream(s, indent + "  ", v.action_feedback);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ATLAS_MSGS_MESSAGE_WALKDEMOACTION_H
