/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/drcsim-3.2.0/handle_msgs/msg/CableTension.msg
 *
 */


#ifndef HANDLE_MSGS_MESSAGE_CABLETENSION_H
#define HANDLE_MSGS_MESSAGE_CABLETENSION_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace handle_msgs
{
template <class ContainerAllocator>
struct CableTension_
{
  typedef CableTension_<ContainerAllocator> Type;

  CableTension_()
    : sensor1(0.0)
    , sensor2(0.0)  {
    }
  CableTension_(const ContainerAllocator& _alloc)
    : sensor1(0.0)
    , sensor2(0.0)  {
    }



   typedef float _sensor1_type;
  _sensor1_type sensor1;

   typedef float _sensor2_type;
  _sensor2_type sensor2;




  typedef boost::shared_ptr< ::handle_msgs::CableTension_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::handle_msgs::CableTension_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct CableTension_

typedef ::handle_msgs::CableTension_<std::allocator<void> > CableTension;

typedef boost::shared_ptr< ::handle_msgs::CableTension > CableTensionPtr;
typedef boost::shared_ptr< ::handle_msgs::CableTension const> CableTensionConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::handle_msgs::CableTension_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::handle_msgs::CableTension_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace handle_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'handle_msgs': ['/tmp/buildd/drcsim-3.2.0/handle_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::handle_msgs::CableTension_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::handle_msgs::CableTension_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::handle_msgs::CableTension_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::handle_msgs::CableTension_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::handle_msgs::CableTension_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::handle_msgs::CableTension_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::handle_msgs::CableTension_<ContainerAllocator> >
{
  static const char* value()
  {
    return "b1e553f0fafb9cb708d68c56bd44d521";
  }

  static const char* value(const ::handle_msgs::CableTension_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xb1e553f0fafb9cb7ULL;
  static const uint64_t static_value2 = 0x08d68c56bd44d521ULL;
};

template<class ContainerAllocator>
struct DataType< ::handle_msgs::CableTension_<ContainerAllocator> >
{
  static const char* value()
  {
    return "handle_msgs/CableTension";
  }

  static const char* value(const ::handle_msgs::CableTension_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::handle_msgs::CableTension_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# The cable tension in one finger of the HANDLE hand.\n\
\n\
float32 sensor1\n\
float32 sensor2\n\
\n\
";
  }

  static const char* value(const ::handle_msgs::CableTension_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::handle_msgs::CableTension_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.sensor1);
      stream.next(m.sensor2);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct CableTension_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::handle_msgs::CableTension_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::handle_msgs::CableTension_<ContainerAllocator>& v)
  {
    s << indent << "sensor1: ";
    Printer<float>::stream(s, indent + "  ", v.sensor1);
    s << indent << "sensor2: ";
    Printer<float>::stream(s, indent + "  ", v.sensor2);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HANDLE_MSGS_MESSAGE_CABLETENSION_H
