"""autogenerated by genpy from atlas_msgs/AtlasBehaviorStepFeedback.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import atlas_msgs.msg

class AtlasBehaviorStepFeedback(genpy.Message):
  _md5sum = "cff2fc0e568e03f6269567166d997b7c"
  _type = "atlas_msgs/AtlasBehaviorStepFeedback"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# mirrored from AtlasControlTypes.h
uint32 STEP_SUBSTATE_SWAYING = 0  # Feet are in double support. This flag does not latch. Only one of STEP_SUBSTATE_SWAYING or STEP_SUBSTATE_STEPPING will be set at any given time.
uint32 STEP_SUBSTATE_STEPPING = 1 # Actively stepping; one foot is in the air. This flag does not latch.

uint32 status_flags    # use AtlasBeahviorFeedback/status_flags
float64 t_step_rem
uint32 current_step_index
uint32 next_step_index_needed
atlas_msgs/AtlasBehaviorStepData desired_step_saturated

================================================================================
MSG: atlas_msgs/AtlasBehaviorStepData
# multi_step walking trajectory parameters
uint32 step_index              # Step index, matlab style, starting from 1,
                               # monotonically increasing during walking
                               #  resets to 1 if robot leaves walk behaviors
uint32 foot_index              # Foot_index can be LEFT_FOOT or RIGHT_FOOT
float64 duration               # Step duration, when in doubt, 0.63s is a
                               # good guess.
geometry_msgs/Pose pose        # Foot pose in Atlas world frame
float64 swing_height           # Step apex swing height measured form the
                               # midpoint between the feet.

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  # Pseudo-constants
  STEP_SUBSTATE_SWAYING = 0
  STEP_SUBSTATE_STEPPING = 1

  __slots__ = ['status_flags','t_step_rem','current_step_index','next_step_index_needed','desired_step_saturated']
  _slot_types = ['uint32','float64','uint32','uint32','atlas_msgs/AtlasBehaviorStepData']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       status_flags,t_step_rem,current_step_index,next_step_index_needed,desired_step_saturated

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AtlasBehaviorStepFeedback, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.status_flags is None:
        self.status_flags = 0
      if self.t_step_rem is None:
        self.t_step_rem = 0.
      if self.current_step_index is None:
        self.current_step_index = 0
      if self.next_step_index_needed is None:
        self.next_step_index_needed = 0
      if self.desired_step_saturated is None:
        self.desired_step_saturated = atlas_msgs.msg.AtlasBehaviorStepData()
    else:
      self.status_flags = 0
      self.t_step_rem = 0.
      self.current_step_index = 0
      self.next_step_index_needed = 0
      self.desired_step_saturated = atlas_msgs.msg.AtlasBehaviorStepData()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_Id4I9d.pack(_x.status_flags, _x.t_step_rem, _x.current_step_index, _x.next_step_index_needed, _x.desired_step_saturated.step_index, _x.desired_step_saturated.foot_index, _x.desired_step_saturated.duration, _x.desired_step_saturated.pose.position.x, _x.desired_step_saturated.pose.position.y, _x.desired_step_saturated.pose.position.z, _x.desired_step_saturated.pose.orientation.x, _x.desired_step_saturated.pose.orientation.y, _x.desired_step_saturated.pose.orientation.z, _x.desired_step_saturated.pose.orientation.w, _x.desired_step_saturated.swing_height))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.desired_step_saturated is None:
        self.desired_step_saturated = atlas_msgs.msg.AtlasBehaviorStepData()
      end = 0
      _x = self
      start = end
      end += 100
      (_x.status_flags, _x.t_step_rem, _x.current_step_index, _x.next_step_index_needed, _x.desired_step_saturated.step_index, _x.desired_step_saturated.foot_index, _x.desired_step_saturated.duration, _x.desired_step_saturated.pose.position.x, _x.desired_step_saturated.pose.position.y, _x.desired_step_saturated.pose.position.z, _x.desired_step_saturated.pose.orientation.x, _x.desired_step_saturated.pose.orientation.y, _x.desired_step_saturated.pose.orientation.z, _x.desired_step_saturated.pose.orientation.w, _x.desired_step_saturated.swing_height,) = _struct_Id4I9d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_Id4I9d.pack(_x.status_flags, _x.t_step_rem, _x.current_step_index, _x.next_step_index_needed, _x.desired_step_saturated.step_index, _x.desired_step_saturated.foot_index, _x.desired_step_saturated.duration, _x.desired_step_saturated.pose.position.x, _x.desired_step_saturated.pose.position.y, _x.desired_step_saturated.pose.position.z, _x.desired_step_saturated.pose.orientation.x, _x.desired_step_saturated.pose.orientation.y, _x.desired_step_saturated.pose.orientation.z, _x.desired_step_saturated.pose.orientation.w, _x.desired_step_saturated.swing_height))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.desired_step_saturated is None:
        self.desired_step_saturated = atlas_msgs.msg.AtlasBehaviorStepData()
      end = 0
      _x = self
      start = end
      end += 100
      (_x.status_flags, _x.t_step_rem, _x.current_step_index, _x.next_step_index_needed, _x.desired_step_saturated.step_index, _x.desired_step_saturated.foot_index, _x.desired_step_saturated.duration, _x.desired_step_saturated.pose.position.x, _x.desired_step_saturated.pose.position.y, _x.desired_step_saturated.pose.position.z, _x.desired_step_saturated.pose.orientation.x, _x.desired_step_saturated.pose.orientation.y, _x.desired_step_saturated.pose.orientation.z, _x.desired_step_saturated.pose.orientation.w, _x.desired_step_saturated.swing_height,) = _struct_Id4I9d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Id4I9d = struct.Struct("<Id4I9d")
