"""autogenerated by genpy from atlas_msgs/AtlasSimInterfaceState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import atlas_msgs.msg
import std_msgs.msg

class AtlasSimInterfaceState(genpy.Message):
  _md5sum = "cac8848356ecf29db9175b861bbf8e75"
  _type = "atlas_msgs/AtlasSimInterfaceState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# For interfacing Boston Dynamics' AtlasSimInterface Dynamics Behavior Library
# Feedback from AtlasSimInterface Controller after calling process_control_input
# This ROS message should track AtlasControlOutput struct in
# AtlasSimInterfaceTypes.h.
# With the exception of addition of k_effort to provide user a way to switch
# to/from PID servo control in AtlasPlugin.cpp on a per joint basis.

int32 NO_ERRORS                        =  0    # no error detected
int32 ERROR_UNSPECIFIED                = -1    # unspecified error
int32 ERROR_VALUE_OUT_OF_RANGE         = -2    # passed value is out of range
int32 ERROR_INVALID_INDEX              = -3    # passed index is invalid (too low or too high)
int32 ERROR_FAILED_TO_START_BEHAVIOR   = -4    # robot failed to start desired behavior
int32 ERROR_NO_ACTIVE_BEHAVIOR         = -5    # robot has no active behavior
int32 ERROR_NO_SUCH_BEHAVIOR           = -6    # behavior doesn't exist
int32 ERROR_BEHAVIOR_NOT_IMPLEMENTED   = -7    # behavior exists but not implemented
int32 ERROR_TIME_RAN_BACKWARD          = -8    # a time earlier than previous times was given

Header header

int32 error_code                         # error code returned by
                                         # process_control_input.
                                         # See AtlasSimInterfaceTypes.h
                                         # AtlasErrorCode for list of enums.
                                         # The list is mimic'd here above.

int32 current_behavior                   # current active behavior.
int32 desired_behavior                   # desired behavior specified by usesr
                                         # input. This may lag from
                                         # current_behavior by a few simulation
                                         # steps.

# below are information from AtlasControlOutput in AtlasSimInterfaceTypes.h

float64[28] f_out                        # torque command from BDI controller.

atlas_msgs/AtlasPositionData pos_est     # Position and velocity estimate of robot pelvis

geometry_msgs/Pose[2] foot_pos_est      # World position estimate for feet
                                         # 0 - left, 1 - right

atlas_msgs/AtlasBehaviorFeedback behavior_feedback
atlas_msgs/AtlasBehaviorStepFeedback step_feedback
atlas_msgs/AtlasBehaviorStandFeedback stand_feedback
atlas_msgs/AtlasBehaviorWalkFeedback walk_feedback
atlas_msgs/AtlasBehaviorManipulateFeedback manipulate_feedback

# additional vector for transitioning from servo model in AtlasPlugin
# to BDI servo.

uint8[] k_effort       # k_effort can be an unsigned int 8value from 0 to 255, 
                       # at run time, a double between 0 and 1 is obtained
                       # by dividing by 255.0d.


================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: atlas_msgs/AtlasPositionData
# mirrors AtlasPositionData in AtlasControlTypes.h
geometry_msgs/Vector3 position
geometry_msgs/Vector3 velocity

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: atlas_msgs/AtlasBehaviorFeedback
# mirrors AtlasBehaviorFeedback
#
# Transition flags:
#    - STATUS_TRANSITION_IN_PROGRESS
#
#        A transition is in progress.
#
#    - STATUS_TRANSITION_SUCCESS
#
#        Successful transition.
#
#    - STATUS_FAILED_TRANS_UNKNOWN_BEHAVIOR
#
#        Failed to transition; unknown behavior.
#
#    - STATUS_FAILED_TRANS_ILLEGAL_BEHAVIOR
#
#        Denied request for an illegal behavior transition.  This may
#        happen if a transition to a new behavior is requested without
#        going through a required intermediate behavior. (e.g., can't
#        go from Walk straight to Manipulate.)
#
#    - STATUS_FAILED_TRANS_COM_POS
#
#        Failed to transition; the position of the COM is too far from
#        the center of support.
#
#    - STATUS_FAILED_TRANS_COM_VEL
#
#        Failed to transition; the COM velocity too high.
#
#    - STATUS_FAILED_TRANS_VEL
#
#        Failed to transition; some joint velocities too high.
#
#  \em Warnings:
#
#    - STATUS_WARNING_AUTO_TRANS
#
#        An automatic transition occurred; see behavior specific
#        feedback for reason.
#
#  \em Errors:
#
#    - STATUS_ERROR_FALLING
#
#        COM below acceptable threshold, cannot recover.

# copied from AtlasBehaviorFlags
uint32 STATUS_OK                            = 0
uint32 STATUS_TRANSITION_IN_PROGRESS        = 1
uint32 STATUS_TRANSITION_SUCCESS            = 2
uint32 STATUS_FAILED_TRANS_UNKNOWN_BEHAVIOR = 4
uint32 STATUS_FAILED_TRANS_ILLEGAL_BEHAVIOR = 8
uint32 STATUS_FAILED_TRANS_COM_POS          = 16
uint32 STATUS_FAILED_TRANS_COM_VEL          = 32
uint32 STATUS_FAILED_TRANS_VEL              = 64
uint32 STATUS_WARNING_AUTO_TRANS            = 128
uint32 STATUS_ERROR_FALLING                 = 256

uint32 status_flags  # can be one of above

int32 trans_from_behavior_index  # use this as a parm to get_behavior_at_index() to get behavior string
int32 trans_to_behavior_index  # use this as a parm to get_behavior_at_index() to get behavior string

================================================================================
MSG: atlas_msgs/AtlasBehaviorStepFeedback
# mirrored from AtlasControlTypes.h
uint32 STEP_SUBSTATE_SWAYING = 0  # Feet are in double support. This flag does not latch. Only one of STEP_SUBSTATE_SWAYING or STEP_SUBSTATE_STEPPING will be set at any given time.
uint32 STEP_SUBSTATE_STEPPING = 1 # Actively stepping; one foot is in the air. This flag does not latch.

uint32 status_flags    # use AtlasBeahviorFeedback/status_flags
float64 t_step_rem
uint32 current_step_index
uint32 next_step_index_needed
atlas_msgs/AtlasBehaviorStepData desired_step_saturated

================================================================================
MSG: atlas_msgs/AtlasBehaviorStepData
# multi_step walking trajectory parameters
uint32 step_index              # Step index, matlab style, starting from 1,
                               # monotonically increasing during walking
                               #  resets to 1 if robot leaves walk behaviors
uint32 foot_index              # Foot_index can be LEFT_FOOT or RIGHT_FOOT
float64 duration               # Step duration, when in doubt, 0.63s is a
                               # good guess.
geometry_msgs/Pose pose        # Foot pose in Atlas world frame
float64 swing_height           # Step apex swing height measured form the
                               # midpoint between the feet.

================================================================================
MSG: atlas_msgs/AtlasBehaviorStandFeedback
# mirrored from AtlasControlTypes.h
uint32 status_flags    # use AtlasBeahviorStandFlags

================================================================================
MSG: atlas_msgs/AtlasBehaviorWalkFeedback
# mirrored from AtlasControlTypes.h
float64 t_step_rem
uint32 current_step_index
uint32 next_step_index_needed
uint32 status_flags    # use AtlasBeahviorFeedback/status_flags
atlas_msgs/AtlasBehaviorStepData[4] step_queue_saturated # 4 is hardcoded in AtlasSimInterface library.

================================================================================
MSG: atlas_msgs/AtlasBehaviorManipulateFeedback
# mirrored from AtlasControlTypes.h
uint32 status_flags    # use AtlasBeahviorManipulateFlags
atlas_msgs/AtlasBehaviorPelvisServoParams clamped

================================================================================
MSG: atlas_msgs/AtlasBehaviorPelvisServoParams
# mirrored from AtlasControlTypes.h

float64 pelvis_height
float64 pelvis_yaw
float64 pelvis_lat

"""
  # Pseudo-constants
  NO_ERRORS = 0
  ERROR_UNSPECIFIED = -1
  ERROR_VALUE_OUT_OF_RANGE = -2
  ERROR_INVALID_INDEX = -3
  ERROR_FAILED_TO_START_BEHAVIOR = -4
  ERROR_NO_ACTIVE_BEHAVIOR = -5
  ERROR_NO_SUCH_BEHAVIOR = -6
  ERROR_BEHAVIOR_NOT_IMPLEMENTED = -7
  ERROR_TIME_RAN_BACKWARD = -8

  __slots__ = ['header','error_code','current_behavior','desired_behavior','f_out','pos_est','foot_pos_est','behavior_feedback','step_feedback','stand_feedback','walk_feedback','manipulate_feedback','k_effort']
  _slot_types = ['std_msgs/Header','int32','int32','int32','float64[28]','atlas_msgs/AtlasPositionData','geometry_msgs/Pose[2]','atlas_msgs/AtlasBehaviorFeedback','atlas_msgs/AtlasBehaviorStepFeedback','atlas_msgs/AtlasBehaviorStandFeedback','atlas_msgs/AtlasBehaviorWalkFeedback','atlas_msgs/AtlasBehaviorManipulateFeedback','uint8[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,error_code,current_behavior,desired_behavior,f_out,pos_est,foot_pos_est,behavior_feedback,step_feedback,stand_feedback,walk_feedback,manipulate_feedback,k_effort

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AtlasSimInterfaceState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.error_code is None:
        self.error_code = 0
      if self.current_behavior is None:
        self.current_behavior = 0
      if self.desired_behavior is None:
        self.desired_behavior = 0
      if self.f_out is None:
        self.f_out = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.pos_est is None:
        self.pos_est = atlas_msgs.msg.AtlasPositionData()
      if self.foot_pos_est is None:
        self.foot_pos_est = [geometry_msgs.msg.Pose(),geometry_msgs.msg.Pose()]
      if self.behavior_feedback is None:
        self.behavior_feedback = atlas_msgs.msg.AtlasBehaviorFeedback()
      if self.step_feedback is None:
        self.step_feedback = atlas_msgs.msg.AtlasBehaviorStepFeedback()
      if self.stand_feedback is None:
        self.stand_feedback = atlas_msgs.msg.AtlasBehaviorStandFeedback()
      if self.walk_feedback is None:
        self.walk_feedback = atlas_msgs.msg.AtlasBehaviorWalkFeedback()
      if self.manipulate_feedback is None:
        self.manipulate_feedback = atlas_msgs.msg.AtlasBehaviorManipulateFeedback()
      if self.k_effort is None:
        self.k_effort = ''
    else:
      self.header = std_msgs.msg.Header()
      self.error_code = 0
      self.current_behavior = 0
      self.desired_behavior = 0
      self.f_out = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.pos_est = atlas_msgs.msg.AtlasPositionData()
      self.foot_pos_est = [geometry_msgs.msg.Pose(),geometry_msgs.msg.Pose()]
      self.behavior_feedback = atlas_msgs.msg.AtlasBehaviorFeedback()
      self.step_feedback = atlas_msgs.msg.AtlasBehaviorStepFeedback()
      self.stand_feedback = atlas_msgs.msg.AtlasBehaviorStandFeedback()
      self.walk_feedback = atlas_msgs.msg.AtlasBehaviorWalkFeedback()
      self.manipulate_feedback = atlas_msgs.msg.AtlasBehaviorManipulateFeedback()
      self.k_effort = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3i.pack(_x.error_code, _x.current_behavior, _x.desired_behavior))
      buff.write(_struct_28d.pack(*self.f_out))
      _x = self
      buff.write(_struct_6d.pack(_x.pos_est.position.x, _x.pos_est.position.y, _x.pos_est.position.z, _x.pos_est.velocity.x, _x.pos_est.velocity.y, _x.pos_est.velocity.z))
      for val1 in self.foot_pos_est:
        _v1 = val1.position
        _x = _v1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v2 = val1.orientation
        _x = _v2
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_I2iId4I9dId3I.pack(_x.behavior_feedback.status_flags, _x.behavior_feedback.trans_from_behavior_index, _x.behavior_feedback.trans_to_behavior_index, _x.step_feedback.status_flags, _x.step_feedback.t_step_rem, _x.step_feedback.current_step_index, _x.step_feedback.next_step_index_needed, _x.step_feedback.desired_step_saturated.step_index, _x.step_feedback.desired_step_saturated.foot_index, _x.step_feedback.desired_step_saturated.duration, _x.step_feedback.desired_step_saturated.pose.position.x, _x.step_feedback.desired_step_saturated.pose.position.y, _x.step_feedback.desired_step_saturated.pose.position.z, _x.step_feedback.desired_step_saturated.pose.orientation.x, _x.step_feedback.desired_step_saturated.pose.orientation.y, _x.step_feedback.desired_step_saturated.pose.orientation.z, _x.step_feedback.desired_step_saturated.pose.orientation.w, _x.step_feedback.desired_step_saturated.swing_height, _x.stand_feedback.status_flags, _x.walk_feedback.t_step_rem, _x.walk_feedback.current_step_index, _x.walk_feedback.next_step_index_needed, _x.walk_feedback.status_flags))
      for val1 in self.walk_feedback.step_queue_saturated:
        _x = val1
        buff.write(_struct_2Id.pack(_x.step_index, _x.foot_index, _x.duration))
        _v3 = val1.pose
        _v4 = _v3.position
        _x = _v4
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v5 = _v3.orientation
        _x = _v5
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.swing_height))
      _x = self
      buff.write(_struct_I3d.pack(_x.manipulate_feedback.status_flags, _x.manipulate_feedback.clamped.pelvis_height, _x.manipulate_feedback.clamped.pelvis_yaw, _x.manipulate_feedback.clamped.pelvis_lat))
      _x = self.k_effort
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.pos_est is None:
        self.pos_est = atlas_msgs.msg.AtlasPositionData()
      if self.foot_pos_est is None:
        self.foot_pos_est = None
      if self.behavior_feedback is None:
        self.behavior_feedback = atlas_msgs.msg.AtlasBehaviorFeedback()
      if self.step_feedback is None:
        self.step_feedback = atlas_msgs.msg.AtlasBehaviorStepFeedback()
      if self.stand_feedback is None:
        self.stand_feedback = atlas_msgs.msg.AtlasBehaviorStandFeedback()
      if self.walk_feedback is None:
        self.walk_feedback = atlas_msgs.msg.AtlasBehaviorWalkFeedback()
      if self.manipulate_feedback is None:
        self.manipulate_feedback = atlas_msgs.msg.AtlasBehaviorManipulateFeedback()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.error_code, _x.current_behavior, _x.desired_behavior,) = _struct_3i.unpack(str[start:end])
      start = end
      end += 224
      self.f_out = _struct_28d.unpack(str[start:end])
      _x = self
      start = end
      end += 48
      (_x.pos_est.position.x, _x.pos_est.position.y, _x.pos_est.position.z, _x.pos_est.velocity.x, _x.pos_est.velocity.y, _x.pos_est.velocity.z,) = _struct_6d.unpack(str[start:end])
      self.foot_pos_est = []
      for i in range(0, 2):
        val1 = geometry_msgs.msg.Pose()
        _v6 = val1.position
        _x = _v6
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v7 = val1.orientation
        _x = _v7
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.foot_pos_est.append(val1)
      _x = self
      start = end
      end += 136
      (_x.behavior_feedback.status_flags, _x.behavior_feedback.trans_from_behavior_index, _x.behavior_feedback.trans_to_behavior_index, _x.step_feedback.status_flags, _x.step_feedback.t_step_rem, _x.step_feedback.current_step_index, _x.step_feedback.next_step_index_needed, _x.step_feedback.desired_step_saturated.step_index, _x.step_feedback.desired_step_saturated.foot_index, _x.step_feedback.desired_step_saturated.duration, _x.step_feedback.desired_step_saturated.pose.position.x, _x.step_feedback.desired_step_saturated.pose.position.y, _x.step_feedback.desired_step_saturated.pose.position.z, _x.step_feedback.desired_step_saturated.pose.orientation.x, _x.step_feedback.desired_step_saturated.pose.orientation.y, _x.step_feedback.desired_step_saturated.pose.orientation.z, _x.step_feedback.desired_step_saturated.pose.orientation.w, _x.step_feedback.desired_step_saturated.swing_height, _x.stand_feedback.status_flags, _x.walk_feedback.t_step_rem, _x.walk_feedback.current_step_index, _x.walk_feedback.next_step_index_needed, _x.walk_feedback.status_flags,) = _struct_I2iId4I9dId3I.unpack(str[start:end])
      self.walk_feedback.step_queue_saturated = []
      for i in range(0, 4):
        val1 = atlas_msgs.msg.AtlasBehaviorStepData()
        _x = val1
        start = end
        end += 16
        (_x.step_index, _x.foot_index, _x.duration,) = _struct_2Id.unpack(str[start:end])
        _v8 = val1.pose
        _v9 = _v8.position
        _x = _v9
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v10 = _v8.orientation
        _x = _v10
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.swing_height,) = _struct_d.unpack(str[start:end])
        self.walk_feedback.step_queue_saturated.append(val1)
      _x = self
      start = end
      end += 28
      (_x.manipulate_feedback.status_flags, _x.manipulate_feedback.clamped.pelvis_height, _x.manipulate_feedback.clamped.pelvis_yaw, _x.manipulate_feedback.clamped.pelvis_lat,) = _struct_I3d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.k_effort = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3i.pack(_x.error_code, _x.current_behavior, _x.desired_behavior))
      buff.write(self.f_out.tostring())
      _x = self
      buff.write(_struct_6d.pack(_x.pos_est.position.x, _x.pos_est.position.y, _x.pos_est.position.z, _x.pos_est.velocity.x, _x.pos_est.velocity.y, _x.pos_est.velocity.z))
      for val1 in self.foot_pos_est:
        _v11 = val1.position
        _x = _v11
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v12 = val1.orientation
        _x = _v12
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_I2iId4I9dId3I.pack(_x.behavior_feedback.status_flags, _x.behavior_feedback.trans_from_behavior_index, _x.behavior_feedback.trans_to_behavior_index, _x.step_feedback.status_flags, _x.step_feedback.t_step_rem, _x.step_feedback.current_step_index, _x.step_feedback.next_step_index_needed, _x.step_feedback.desired_step_saturated.step_index, _x.step_feedback.desired_step_saturated.foot_index, _x.step_feedback.desired_step_saturated.duration, _x.step_feedback.desired_step_saturated.pose.position.x, _x.step_feedback.desired_step_saturated.pose.position.y, _x.step_feedback.desired_step_saturated.pose.position.z, _x.step_feedback.desired_step_saturated.pose.orientation.x, _x.step_feedback.desired_step_saturated.pose.orientation.y, _x.step_feedback.desired_step_saturated.pose.orientation.z, _x.step_feedback.desired_step_saturated.pose.orientation.w, _x.step_feedback.desired_step_saturated.swing_height, _x.stand_feedback.status_flags, _x.walk_feedback.t_step_rem, _x.walk_feedback.current_step_index, _x.walk_feedback.next_step_index_needed, _x.walk_feedback.status_flags))
      for val1 in self.walk_feedback.step_queue_saturated:
        _x = val1
        buff.write(_struct_2Id.pack(_x.step_index, _x.foot_index, _x.duration))
        _v13 = val1.pose
        _v14 = _v13.position
        _x = _v14
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v15 = _v13.orientation
        _x = _v15
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_d.pack(val1.swing_height))
      _x = self
      buff.write(_struct_I3d.pack(_x.manipulate_feedback.status_flags, _x.manipulate_feedback.clamped.pelvis_height, _x.manipulate_feedback.clamped.pelvis_yaw, _x.manipulate_feedback.clamped.pelvis_lat))
      _x = self.k_effort
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.pos_est is None:
        self.pos_est = atlas_msgs.msg.AtlasPositionData()
      if self.foot_pos_est is None:
        self.foot_pos_est = None
      if self.behavior_feedback is None:
        self.behavior_feedback = atlas_msgs.msg.AtlasBehaviorFeedback()
      if self.step_feedback is None:
        self.step_feedback = atlas_msgs.msg.AtlasBehaviorStepFeedback()
      if self.stand_feedback is None:
        self.stand_feedback = atlas_msgs.msg.AtlasBehaviorStandFeedback()
      if self.walk_feedback is None:
        self.walk_feedback = atlas_msgs.msg.AtlasBehaviorWalkFeedback()
      if self.manipulate_feedback is None:
        self.manipulate_feedback = atlas_msgs.msg.AtlasBehaviorManipulateFeedback()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.error_code, _x.current_behavior, _x.desired_behavior,) = _struct_3i.unpack(str[start:end])
      start = end
      end += 224
      self.f_out = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=28)
      _x = self
      start = end
      end += 48
      (_x.pos_est.position.x, _x.pos_est.position.y, _x.pos_est.position.z, _x.pos_est.velocity.x, _x.pos_est.velocity.y, _x.pos_est.velocity.z,) = _struct_6d.unpack(str[start:end])
      self.foot_pos_est = []
      for i in range(0, 2):
        val1 = geometry_msgs.msg.Pose()
        _v16 = val1.position
        _x = _v16
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v17 = val1.orientation
        _x = _v17
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.foot_pos_est.append(val1)
      _x = self
      start = end
      end += 136
      (_x.behavior_feedback.status_flags, _x.behavior_feedback.trans_from_behavior_index, _x.behavior_feedback.trans_to_behavior_index, _x.step_feedback.status_flags, _x.step_feedback.t_step_rem, _x.step_feedback.current_step_index, _x.step_feedback.next_step_index_needed, _x.step_feedback.desired_step_saturated.step_index, _x.step_feedback.desired_step_saturated.foot_index, _x.step_feedback.desired_step_saturated.duration, _x.step_feedback.desired_step_saturated.pose.position.x, _x.step_feedback.desired_step_saturated.pose.position.y, _x.step_feedback.desired_step_saturated.pose.position.z, _x.step_feedback.desired_step_saturated.pose.orientation.x, _x.step_feedback.desired_step_saturated.pose.orientation.y, _x.step_feedback.desired_step_saturated.pose.orientation.z, _x.step_feedback.desired_step_saturated.pose.orientation.w, _x.step_feedback.desired_step_saturated.swing_height, _x.stand_feedback.status_flags, _x.walk_feedback.t_step_rem, _x.walk_feedback.current_step_index, _x.walk_feedback.next_step_index_needed, _x.walk_feedback.status_flags,) = _struct_I2iId4I9dId3I.unpack(str[start:end])
      self.walk_feedback.step_queue_saturated = []
      for i in range(0, 4):
        val1 = atlas_msgs.msg.AtlasBehaviorStepData()
        _x = val1
        start = end
        end += 16
        (_x.step_index, _x.foot_index, _x.duration,) = _struct_2Id.unpack(str[start:end])
        _v18 = val1.pose
        _v19 = _v18.position
        _x = _v19
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v20 = _v18.orientation
        _x = _v20
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 8
        (val1.swing_height,) = _struct_d.unpack(str[start:end])
        self.walk_feedback.step_queue_saturated.append(val1)
      _x = self
      start = end
      end += 28
      (_x.manipulate_feedback.status_flags, _x.manipulate_feedback.clamped.pelvis_height, _x.manipulate_feedback.clamped.pelvis_yaw, _x.manipulate_feedback.clamped.pelvis_lat,) = _struct_I3d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.k_effort = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_6d = struct.Struct("<6d")
_struct_d = struct.Struct("<d")
_struct_3i = struct.Struct("<3i")
_struct_28d = struct.Struct("<28d")
_struct_I2iId4I9dId3I = struct.Struct("<I2iId4I9dId3I")
_struct_3I = struct.Struct("<3I")
_struct_4d = struct.Struct("<4d")
_struct_I3d = struct.Struct("<I3d")
_struct_2Id = struct.Struct("<2Id")
_struct_3d = struct.Struct("<3d")
