"""autogenerated by genpy from handle_msgs/HandleSensors.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import handle_msgs.msg
import std_msgs.msg

class HandleSensors(genpy.Message):
  _md5sum = "41aa19d900cfb7233222088d703520cf"
  _type = "handle_msgs/HandleSensors"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# All of the sensors on the HANDLE hand.
#
# NOTE: In general, the order of the arrays is: [F1, F2, F3, F3 Ant., Spread].
# Where: F1 is analogous to your right hand index finger, F2 is analogous to 
# your right middle finger, F3 is analogous to your right thumb, F3 Ant. is 
# the antagonistic motor for F3, and Spread is the motor which controls the 
# rotation of F1 and F2.
#

# Currently only used for time stamp.  Time stamp set from Overo's clock.
# Not guaranteed to be in sync with the current time.
Header header

# The hall effect sensor on the finger motors.  
# 24 counts per motor revolution x 300 motor revolutions for one full spindle
# rotation.  
# 3500 to put finger at approx. 90 degrees
# 6000 to close finger gently
# 7000 to close finger tightly
#
# [F1, F2, F3, F3 Ant.]
int32[4] motorHallEncoder

# The temperature of the finger motor windings, in Celsius.
#
# [F1, F2, F3, F3 Ant.]
float32[4] motorWindingTemp

# The air temperature as measured inside the housing, in Celsius.
float32 airTemp

# The motor velocity in RPM.  (Hall encoder ticks per minute)
#
# [F1, F2, F3, F3 Ant.]
int32[4] motorVelocity

# The temperature of the motor housing, in Celsius.
# Note that the housing temp for the Spread motor is not populated, so will
# not have a logical value.
#
# [F1, F2, F3, F3 Ant., Spread]
float32[5] motorHousingTemp

# The motor current in amps.
#
# [F1, F2, F3, F3 Ant., Spread]
float32[5] motorCurrent

# The tactile array for each finger.  In units of ADC counts.
# Note there are 12 proximal and 10 distal sensors.
#
# [F1, F2, F3]
Finger[3] fingerTactile

# The tactile temperature array for each finger, in Celsius.
# Note there are 12 proximal and 10 distal sensors.
#
# [F1, F2, F3]
Finger[3] fingerTactileTemp

# The tactile array for the palm.  In units of ADC counts.
float32[48] palmTactile

# The tactile temperature array for the palm, in Celsius.
float32[48] palmTactileTemp

# The encoder on the F1 / F2 rotation. 8.533 ticks per degree.
# 3072 ticks per 180 degree rotation. (not possible).
# 768 ticks to rotate the fingers 90 degrees for a "T" grasp.
# 512 ticks to rotate the fingers 60 degrees for a spherical grasp.
int32 fingerSpread

# The proximal joint angle.  Approx 2.84 ticks per degree.
# 1024 ticks per full revolution. (not possible)
# 256 ticks to put finger at approx. 90 degrees
# 435 ticks to close finger gently
# 445 ticks to close finger tightly
#
# [F1, F2, F3]
int32[3] proximalJointAngle

# The finger distal joint flexture angle
# [F1, F2, F3]
# Note there are 4 readings on either side of the joint.
Finger[3] distalJointAngle

# The accelerometer in the proximal link of each finger.  In G's.
# This sensor is not populated at this time.
#
# [F1, F2, F3]
geometry_msgs/Vector3[3] proximalAcceleration

# The accelerometer in the distal link of each finger.  In G's.
# Z axis points out the back of the finger.
# Y axis points out the finger tip.
# X axis points to the left when looking at the finger pad.
#
# [F1, F2, F3]
geometry_msgs/Vector3[3] distalAcceleration

# In this sensor message, which devices actually contributed data.
# The order of the array is:
#  0: Palm (Traffic Cop)
#  1: Finger 1 Proximal
#  2: Finger 1 Distal
#  3: Finger 2 Proximal
#  4: Finger 2 Distal
#  5: Finger 3 Proximal
#  6: Finger 3 Distal
#  7: Motor for Finger 1
#  8: Motor for Finger 2
#  9: Motor for Finger 3
# 10: Motor for Finger 3 Antagonist
# 11: Tactile Palm
bool[12] responses

# How many of the the last 100 messages had data from each device.
# This gives a good indication of communication quality between the devices.
# Note that this only counts sensor message history.  If you have a motor that
# is in thermal shutdown and non-responsive, the device may look fine here.
# However there will be errors in the motorError array below.
# The order of the array is:
#  0: Palm (Traffic Cop)
#  1: Finger 1 Proximal
#  2: Finger 1 Distal
#  3: Finger 2 Proximal
#  4: Finger 2 Distal
#  5: Finger 3 Proximal
#  6: Finger 3 Distal
#  7: Motor for Finger 1
#  8: Motor for Finger 2
#  9: Motor for Finger 3
# 10: Motor for Finger 3 Antagonist
# 11: Tactile Palm
int8[12] responseHistory

# The last received error from each motor.
# The order of the motors in the array:
# [F1, F2, F3, F3 Ant., Spread]
# The error codes are:
#   0 = No Error
#   1 = Traffic Cop checksum error
#   2 = Unknown Command
#   3 = Bad Address
#   4 = Traffic Cop timeout waiting for response
#  17 = Overo checksum error
#  18 = Overo data length error
#  20 = Overo timout waiting for response
# 128 = Thermal Protection Delay
# 129 = Mandatory Cool Down 
# 130 = Request out of range
int16[5] motorError

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: handle_msgs/Finger
# This finger definition is used for different sensors in the HandleSensors 
# message type.  

float32[] proximal
float32[] distal


================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['header','motorHallEncoder','motorWindingTemp','airTemp','motorVelocity','motorHousingTemp','motorCurrent','fingerTactile','fingerTactileTemp','palmTactile','palmTactileTemp','fingerSpread','proximalJointAngle','distalJointAngle','proximalAcceleration','distalAcceleration','responses','responseHistory','motorError']
  _slot_types = ['std_msgs/Header','int32[4]','float32[4]','float32','int32[4]','float32[5]','float32[5]','handle_msgs/Finger[3]','handle_msgs/Finger[3]','float32[48]','float32[48]','int32','int32[3]','handle_msgs/Finger[3]','geometry_msgs/Vector3[3]','geometry_msgs/Vector3[3]','bool[12]','int8[12]','int16[5]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,motorHallEncoder,motorWindingTemp,airTemp,motorVelocity,motorHousingTemp,motorCurrent,fingerTactile,fingerTactileTemp,palmTactile,palmTactileTemp,fingerSpread,proximalJointAngle,distalJointAngle,proximalAcceleration,distalAcceleration,responses,responseHistory,motorError

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HandleSensors, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.motorHallEncoder is None:
        self.motorHallEncoder = [0,0,0,0]
      if self.motorWindingTemp is None:
        self.motorWindingTemp = [0.,0.,0.,0.]
      if self.airTemp is None:
        self.airTemp = 0.
      if self.motorVelocity is None:
        self.motorVelocity = [0,0,0,0]
      if self.motorHousingTemp is None:
        self.motorHousingTemp = [0.,0.,0.,0.,0.]
      if self.motorCurrent is None:
        self.motorCurrent = [0.,0.,0.,0.,0.]
      if self.fingerTactile is None:
        self.fingerTactile = [handle_msgs.msg.Finger(),handle_msgs.msg.Finger(),handle_msgs.msg.Finger()]
      if self.fingerTactileTemp is None:
        self.fingerTactileTemp = [handle_msgs.msg.Finger(),handle_msgs.msg.Finger(),handle_msgs.msg.Finger()]
      if self.palmTactile is None:
        self.palmTactile = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.palmTactileTemp is None:
        self.palmTactileTemp = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]
      if self.fingerSpread is None:
        self.fingerSpread = 0
      if self.proximalJointAngle is None:
        self.proximalJointAngle = [0,0,0]
      if self.distalJointAngle is None:
        self.distalJointAngle = [handle_msgs.msg.Finger(),handle_msgs.msg.Finger(),handle_msgs.msg.Finger()]
      if self.proximalAcceleration is None:
        self.proximalAcceleration = [geometry_msgs.msg.Vector3(),geometry_msgs.msg.Vector3(),geometry_msgs.msg.Vector3()]
      if self.distalAcceleration is None:
        self.distalAcceleration = [geometry_msgs.msg.Vector3(),geometry_msgs.msg.Vector3(),geometry_msgs.msg.Vector3()]
      if self.responses is None:
        self.responses = [False,False,False,False,False,False,False,False,False,False,False,False]
      if self.responseHistory is None:
        self.responseHistory = [0,0,0,0,0,0,0,0,0,0,0,0]
      if self.motorError is None:
        self.motorError = [0,0,0,0,0]
    else:
      self.header = std_msgs.msg.Header()
      self.motorHallEncoder = [0,0,0,0]
      self.motorWindingTemp = [0.,0.,0.,0.]
      self.airTemp = 0.
      self.motorVelocity = [0,0,0,0]
      self.motorHousingTemp = [0.,0.,0.,0.,0.]
      self.motorCurrent = [0.,0.,0.,0.,0.]
      self.fingerTactile = [handle_msgs.msg.Finger(),handle_msgs.msg.Finger(),handle_msgs.msg.Finger()]
      self.fingerTactileTemp = [handle_msgs.msg.Finger(),handle_msgs.msg.Finger(),handle_msgs.msg.Finger()]
      self.palmTactile = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.palmTactileTemp = [0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.]
      self.fingerSpread = 0
      self.proximalJointAngle = [0,0,0]
      self.distalJointAngle = [handle_msgs.msg.Finger(),handle_msgs.msg.Finger(),handle_msgs.msg.Finger()]
      self.proximalAcceleration = [geometry_msgs.msg.Vector3(),geometry_msgs.msg.Vector3(),geometry_msgs.msg.Vector3()]
      self.distalAcceleration = [geometry_msgs.msg.Vector3(),geometry_msgs.msg.Vector3(),geometry_msgs.msg.Vector3()]
      self.responses = [False,False,False,False,False,False,False,False,False,False,False,False]
      self.responseHistory = [0,0,0,0,0,0,0,0,0,0,0,0]
      self.motorError = [0,0,0,0,0]

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_4i.pack(*self.motorHallEncoder))
      buff.write(_struct_4f.pack(*self.motorWindingTemp))
      buff.write(_struct_f.pack(self.airTemp))
      buff.write(_struct_4i.pack(*self.motorVelocity))
      buff.write(_struct_5f.pack(*self.motorHousingTemp))
      buff.write(_struct_5f.pack(*self.motorCurrent))
      for val1 in self.fingerTactile:
        length = len(val1.proximal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.proximal))
        length = len(val1.distal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.distal))
      for val1 in self.fingerTactileTemp:
        length = len(val1.proximal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.proximal))
        length = len(val1.distal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.distal))
      buff.write(_struct_48f.pack(*self.palmTactile))
      buff.write(_struct_48f.pack(*self.palmTactileTemp))
      buff.write(_struct_i.pack(self.fingerSpread))
      buff.write(_struct_3i.pack(*self.proximalJointAngle))
      for val1 in self.distalJointAngle:
        length = len(val1.proximal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.proximal))
        length = len(val1.distal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.distal))
      for val1 in self.proximalAcceleration:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      for val1 in self.distalAcceleration:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      buff.write(_struct_12B.pack(*self.responses))
      buff.write(_struct_12b.pack(*self.responseHistory))
      buff.write(_struct_5h.pack(*self.motorError))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.fingerTactile is None:
        self.fingerTactile = None
      if self.fingerTactileTemp is None:
        self.fingerTactileTemp = None
      if self.distalJointAngle is None:
        self.distalJointAngle = None
      if self.proximalAcceleration is None:
        self.proximalAcceleration = None
      if self.distalAcceleration is None:
        self.distalAcceleration = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 16
      self.motorHallEncoder = _struct_4i.unpack(str[start:end])
      start = end
      end += 16
      self.motorWindingTemp = _struct_4f.unpack(str[start:end])
      start = end
      end += 4
      (self.airTemp,) = _struct_f.unpack(str[start:end])
      start = end
      end += 16
      self.motorVelocity = _struct_4i.unpack(str[start:end])
      start = end
      end += 20
      self.motorHousingTemp = _struct_5f.unpack(str[start:end])
      start = end
      end += 20
      self.motorCurrent = _struct_5f.unpack(str[start:end])
      self.fingerTactile = []
      for i in range(0, 3):
        val1 = handle_msgs.msg.Finger()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.proximal = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.distal = struct.unpack(pattern, str[start:end])
        self.fingerTactile.append(val1)
      self.fingerTactileTemp = []
      for i in range(0, 3):
        val1 = handle_msgs.msg.Finger()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.proximal = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.distal = struct.unpack(pattern, str[start:end])
        self.fingerTactileTemp.append(val1)
      start = end
      end += 192
      self.palmTactile = _struct_48f.unpack(str[start:end])
      start = end
      end += 192
      self.palmTactileTemp = _struct_48f.unpack(str[start:end])
      start = end
      end += 4
      (self.fingerSpread,) = _struct_i.unpack(str[start:end])
      start = end
      end += 12
      self.proximalJointAngle = _struct_3i.unpack(str[start:end])
      self.distalJointAngle = []
      for i in range(0, 3):
        val1 = handle_msgs.msg.Finger()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.proximal = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.distal = struct.unpack(pattern, str[start:end])
        self.distalJointAngle.append(val1)
      self.proximalAcceleration = []
      for i in range(0, 3):
        val1 = geometry_msgs.msg.Vector3()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.proximalAcceleration.append(val1)
      self.distalAcceleration = []
      for i in range(0, 3):
        val1 = geometry_msgs.msg.Vector3()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.distalAcceleration.append(val1)
      start = end
      end += 12
      self.responses = _struct_12B.unpack(str[start:end])
      self.responses = map(bool, self.responses)
      start = end
      end += 12
      self.responseHistory = _struct_12b.unpack(str[start:end])
      start = end
      end += 10
      self.motorError = _struct_5h.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(self.motorHallEncoder.tostring())
      buff.write(self.motorWindingTemp.tostring())
      buff.write(_struct_f.pack(self.airTemp))
      buff.write(self.motorVelocity.tostring())
      buff.write(self.motorHousingTemp.tostring())
      buff.write(self.motorCurrent.tostring())
      for val1 in self.fingerTactile:
        length = len(val1.proximal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.proximal.tostring())
        length = len(val1.distal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.distal.tostring())
      for val1 in self.fingerTactileTemp:
        length = len(val1.proximal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.proximal.tostring())
        length = len(val1.distal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.distal.tostring())
      buff.write(self.palmTactile.tostring())
      buff.write(self.palmTactileTemp.tostring())
      buff.write(_struct_i.pack(self.fingerSpread))
      buff.write(self.proximalJointAngle.tostring())
      for val1 in self.distalJointAngle:
        length = len(val1.proximal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.proximal.tostring())
        length = len(val1.distal)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.distal.tostring())
      for val1 in self.proximalAcceleration:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      for val1 in self.distalAcceleration:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      buff.write(self.responses.tostring())
      buff.write(self.responseHistory.tostring())
      buff.write(self.motorError.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.fingerTactile is None:
        self.fingerTactile = None
      if self.fingerTactileTemp is None:
        self.fingerTactileTemp = None
      if self.distalJointAngle is None:
        self.distalJointAngle = None
      if self.proximalAcceleration is None:
        self.proximalAcceleration = None
      if self.distalAcceleration is None:
        self.distalAcceleration = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 16
      self.motorHallEncoder = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=4)
      start = end
      end += 16
      self.motorWindingTemp = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=4)
      start = end
      end += 4
      (self.airTemp,) = _struct_f.unpack(str[start:end])
      start = end
      end += 16
      self.motorVelocity = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=4)
      start = end
      end += 20
      self.motorHousingTemp = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=5)
      start = end
      end += 20
      self.motorCurrent = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=5)
      self.fingerTactile = []
      for i in range(0, 3):
        val1 = handle_msgs.msg.Finger()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.proximal = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.distal = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.fingerTactile.append(val1)
      self.fingerTactileTemp = []
      for i in range(0, 3):
        val1 = handle_msgs.msg.Finger()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.proximal = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.distal = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.fingerTactileTemp.append(val1)
      start = end
      end += 192
      self.palmTactile = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=48)
      start = end
      end += 192
      self.palmTactileTemp = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=48)
      start = end
      end += 4
      (self.fingerSpread,) = _struct_i.unpack(str[start:end])
      start = end
      end += 12
      self.proximalJointAngle = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=3)
      self.distalJointAngle = []
      for i in range(0, 3):
        val1 = handle_msgs.msg.Finger()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.proximal = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.distal = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.distalJointAngle.append(val1)
      self.proximalAcceleration = []
      for i in range(0, 3):
        val1 = geometry_msgs.msg.Vector3()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.proximalAcceleration.append(val1)
      self.distalAcceleration = []
      for i in range(0, 3):
        val1 = geometry_msgs.msg.Vector3()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.distalAcceleration.append(val1)
      start = end
      end += 12
      self.responses = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=12)
      self.responses = map(bool, self.responses)
      start = end
      end += 12
      self.responseHistory = numpy.frombuffer(str[start:end], dtype=numpy.int8, count=12)
      start = end
      end += 10
      self.motorError = numpy.frombuffer(str[start:end], dtype=numpy.int16, count=5)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_12B = struct.Struct("<12B")
_struct_f = struct.Struct("<f")
_struct_i = struct.Struct("<i")
_struct_48f = struct.Struct("<48f")
_struct_3i = struct.Struct("<3i")
_struct_3I = struct.Struct("<3I")
_struct_5h = struct.Struct("<5h")
_struct_4i = struct.Struct("<4i")
_struct_4f = struct.Struct("<4f")
_struct_12b = struct.Struct("<12b")
_struct_5f = struct.Struct("<5f")
_struct_3d = struct.Struct("<3d")
